import {createVNode, render} from "vue";
import toast from "@/components/yvan-ui/yvan-print-toast/toast.vue";

let mountNode: any = null;

export default (options: any) => {
    const duration = options.duration | 3000;
    //确保只存在一个弹框，如果前一个弹窗还在，就移除
    if (mountNode) {
        document.body.removeChild(mountNode);
        mountNode = null;
    }
    //将options参数传入，并将toast组件转换成虚拟DOM，并赋值给app
    const app = createVNode(toast, {
        ...options,
        duration,
        visible: true,
    });
    //创建定时器，duration时间后将mountNode移除
    let timer = setTimeout(() => {
        document.body.removeChild(mountNode);
        mountNode = null;
        clearTimeout(timer);
    }, duration);
    //创建一个空的div
    mountNode = document.createElement("div");
    //render函数的作用就是将toast组件的虚拟DOM转换成真实DOM并插入到mountNode元素里
    render(app, mountNode);
    //然后把转换成真实DOM的toast组件插入到body里
    document.body.appendChild(mountNode);
};