import {system} from '@/utils/system';
import {deepCopy} from '@/utils/html-util';
import {elementList} from "@/components/config/globalConfig";

export default {
    methods: {
        deepCopy,
        getUuid: system.getUuid,
        isBlank(value) {
            return value === undefined || value === null || value === ''
        },
        findParentComponent(vueIns, name) {
            let parent = vueIns.$parent
            while (parent) {
                let componentName = parent.$options.componentName || parent.$options.name
                if (componentName !== name) {
                    parent = parent.$parent
                } else {
                    return parent
                }
            }
            return false
        },
        findElementByCode(elementCode){
            if (!elementList || elementList.length <= 0) {
                return
            }
            return elementList.findLast(element => element.code === elementCode)
        }
    }
}
