import Utils from '@/utils/utils'
import {system} from '@/utils/system'
import {deepCopy} from '@/utils/html-util'

export default {
    state: {
        copyData: null, // 复制粘贴剪切
        isCut: false,
        menuTop: 0, // 右击菜单数据
        menuLeft: 0
    },
    actions: {
        copy() {
            if (!this.curComponent) {
                system.toast('请选择组件')
                return
            }

            // 如果有剪切的数据，需要先还原
            restorePreCutData()
            copyData()

            this.isCut = false
        },

        paste(isMouse) {
            if (!this.copyData) {
                // toast('请选择组件')
                return
            }

            const data = this.copyData.data

            if (isMouse) {
                data.style.top = this.menuTop
                data.style.left = this.menuLeft
            } else {
                data.style.top += 10
                data.style.left += 10
            }

            data.id = Utils.getUuid()
            data.label = `${data.name}-${data.id}`
            // store.commit('printTemplateModule/addComponent', {
            //   component: deepCopy(data)
            // })
            if (this.isCut) {
                this.copyData = null
            }
        },

        cut() {
            if (!this.curComponent) {
                system.toast('请选择组件')
                return
            }

            // 如果重复剪切，需要恢复上一次剪切的数据
            restorePreCutData()
            copyData()

            this.deleteComponent()
            this.isCut = true
        },

        showContextMenu({top, left}) {
            this.menuTop = top
            this.menuLeft = left
        }
    }
}

// 恢复上一次剪切的数据
function restorePreCutData() {
    if (this.isCut && this.copyData) {
        const data = deepCopy(this.copyData.data)
        const index = this.copyData.index
        // store.commit('addComponent', { component: data, index })
        if (this.curComponentIndex >= index) {
            // 如果当前组件索引大于等于插入索引，需要加一，因为当前组件往后移了一位
            this.curComponentIndex++
        }
    }
}

function copyData() {
    this.copyData = {
        data: deepCopy(this.curComponent),
        index: this.curComponentIndex
    }
}
