import CONSTANT from '@/utils/constant'
import {defineStore} from "pinia";

const {STORAGE_PREFIX} = CONSTANT

export const modeStore = defineStore("nightMode", {
    state: () => ({
        isNightMode: false
    }),
    actions: {
        toggleNightMode(isNightMode) {
            window.localStorage.setItem(`${STORAGE_PREFIX}NIGHT_MODE`, JSON.stringify(isNightMode))
            document
                .getElementById('yvan-print-designer')
                .setAttribute('theme', isNightMode ? 'dark' : 'day')
            this.isNightMode = isNightMode
        },
        async initNightMode({dispatch}) {
            const nightMode = window.localStorage.getItem(`${STORAGE_PREFIX}NIGHT_MODE`)
            if (nightMode) {
                this.toggleNightMode(JSON.parse(nightMode))
                // await dispatch('toggleNightMode', JSON.parse(nightMode))
            }
        },
    }
})